/**
 * 
 */
package com.sonata.Ebreez.dynamictable;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.SortedMap;
import java.util.TreeMap;

import javax.faces.event.ActionEvent;

import org.apache.commons.lang.StringUtils;
import org.richfaces.component.html.HtmlDataTable;
import org.richfaces.model.Ordering;

/**
 * @author vishwanath.bb
 *
 */
public class TableBean {
	
	private String name;
	private String code;
	private String id;
	SortedMap<String, String> columnHeaders = new TreeMap<String, String>();
	HtmlDataTable data = new HtmlDataTable();

	/**
	 * 
	 */
	public TableBean() {
			init();
		
	} 
	
	private Region region;
	
	private List<Region> regins;
	
	public void init(){
		regins = new ArrayList<Region>();
		
		region = new Region();
		region.setRgnId("US1");
		region.setRgnCode("001US");
		region.setRgnName("US");
		regins.add(region);
		
		region = new Region();
		region.setRgnId("UK2");
		region.setRgnCode("002UK");
		region.setRgnName("UK");
		regins.add(region);
		
		region = new Region();
		region.setRgnId("IN3");
		region.setRgnCode("003IN");
		region.setRgnName("IN");
		regins.add(region);
		
		region = new Region();
		region.setRgnId("AUS4");
		region.setRgnCode("004AUS");
		region.setRgnName("AUS");
		regins.add(region); 
		
		columnHeaders.put("RGN_ID", "rgnId");
		columnHeaders.put("RGN_CODE", "rgnCode");
		columnHeaders.put("RGN_NAME", "rgnName");		
		createDataTable(regins,columnHeaders);
	}
	
	public void save(){
		region = new Region();
		region.setRgnId(getId());
		region.setRgnCode(getCode());
		region.setRgnName(getName());
		regins.add(region);
		createDataTable(regins,columnHeaders);
	}
	
	public void edit(){
		
		data.getRowData();
		data.getRowIndex();
		int index = 0;
		index = data.getRowIndex();
		//(Integer) event.getComponent().getAttributes().get("editBtn");		
		if (regins != null ) {
			Region region = regins.get(index);
			setId(region.getRgnId());
			setCode(region.getRgnCode());
			setName(region.getRgnName());
		}
		 
	}
	
	
	
	static final String ROW_PREFIX = "Row";	
	static final String CELL_PREFIX = "Cell";
	
	String status;
	
	boolean rendered = true;
	boolean selfSorted = true; 
	
	Comparator<Row[]> comparator = new Comparator<Row[]>(){
		
		public int compare(Row[] o1, Row[] o2) {
			return new Integer(o1[0].value).compareTo(o2[0].value);
		}
		
	};
	
	private int rows = 2;
	
	private int cols = 4;
	
	private int headerCols = 5;
	
	private List<Row []> model;
	
	private List<Column> columns;
	
	private List<Column> headerColumns;
	
	
	
	private void createDataTable(List<Region> regins, Map<String, String> columnHeaders) {
		columns = new ArrayList<Column>(); 
		int columnCount = columnHeaders.size();
		Set<String> Headers = columnHeaders.keySet();
		for (String header : Headers) {
			columns.add(new Column(header, "Footer"+header));
		} 
		columns.add(new Column("", ""));
		model = new ArrayList<Row[]>(); 
		for (int i = 0; i < regins.size(); i++) {
			Row[] rows = new Row [columnCount+1];
			int j=0;
			for (String header : Headers) {
				rows[j] = new Row(i + j, getValueFromObject(regins.get(i), columnHeaders.get(header)).toString());
				j++;
			} 
			rows[j] = new Row(i + j, "button"); 
			model.add(rows);
		}
		
		data.setValue(model);
	}
	
	public void reset() {
		init();
		status = null;
		rendered = true;
		selfSorted = true;
	}
	
	public void prepareRenderedTest () {
		reset();
		rendered = false;
	}
	
	public void prepareExternalSorting () {
		reset();
		selfSorted = false;
	}
	
	public String sortAscending() {
		for (Column c : columns) {
			c.setOrdering(Ordering.ASCENDING);
		}
		return null;
	}
	
	public String sortDescending() {
		for (Column c : columns) {
			c.setOrdering(Ordering.DESCENDING);
		}
		return null;
	}

	public List<Row[]> getModel() {
		return model;
	}

	public void setModel(List<Row[]> model) {
		this.model = model;
	}

	public List<Column> getColumns() {
		return columns;
	}

	public void setColumns(List<Column> columns) {
		this.columns = columns;
	}
	
	public boolean getCheckInputs() {
		Iterator<Row[]> it = model.iterator();
		int row = 0;
		boolean f = true;
		while (it.hasNext()) {
			Row[] r = it.next();
			for (int i = 0; i < cols; i++) {
				String e = ROW_PREFIX + row + CELL_PREFIX + i;
				if (!e.equals(r[i].input)) {
					f = false;
				}
			}
			row++;
		}
		return f;
	}

	public String getStatus() {
		return (status != null) ? status : "";
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public Comparator<Row[]> getComparator() {
		return comparator;
	}

	public void setComparator(Comparator<Row[]> comparator) {
		this.comparator = comparator;
	}

	public List<Column> getHeaderColumns() {
		if (headerColumns == null) {
			headerColumns = new ArrayList<Column>();
			for (int i = 0; i < headerCols; i++) {
				headerColumns.add(new Column("Header" + i, "Footer" + i));
			}
		}
		return headerColumns;
	}

	public boolean isRendered() {
		return rendered;
	}

	public boolean isSelfSorted() {
		return selfSorted;
	}
	
	
	public Object getValueFromObject(Object objInstance, String propertyName) {

		try {

			Class classInstance = objInstance.getClass();

			String methodName = "get" + StringUtils.capitalize(propertyName);

			Class methodParamTypes[] = new Class[] {};

			Method method = classInstance.getMethod(methodName,
					methodParamTypes);

			Object methodParamValues[] = new Object[] {};

			Object returnObj = method.invoke(objInstance, methodParamValues);

			return returnObj;
		} catch (Exception e) {

		}
		return "";
	}

	/**
	 * @return the regins
	 */
	public List<Region> getRegins() {
		return regins;
	}

	/**
	 * @param regins the regins to set
	 */
	public void setRegins(List<Region> regins) {
		this.regins = regins;
	}

	/**
	 * @return the region
	 */
	public Region getRegion() {
		return region;
	}

	/**
	 * @param region the region to set
	 */
	public void setRegion(Region region) {
		this.region = region;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the code
	 */
	public String getCode() {
		return code;
	}

	/**
	 * @param code the code to set
	 */
	public void setCode(String code) {
		this.code = code;
	}

	/**
	 * @return the id
	 */
	public String getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * @return the data
	 */
	public HtmlDataTable getData() {
		return data;
	}

	/**
	 * @param data the data to set
	 */
	public void setData(HtmlDataTable data) {
		this.data = data;
	}


}
